// 库存调整制单
import React from 'react';
import { Card, Row, Col, Form, DatePicker, Select, Switch, Input, Button, message, Popconfirm, Upload, Tooltip, Icon } from 'antd';
import { $http } from 'containers/config/https';
import { Util } from 'tools'
import Moment from 'moment';
import AdjustmentDetailList from './component/AdjustmentDetailList.jsx';
import InquireShift from './component/InquireShift.jsx';
import './style/index.less';
import {printStkAdj} from '../commonPrint/stkPrint';

const { Option } = Select;
const { TextArea } = Input;

function isObjEqual(o1,o2){
    var props1 = Object.getOwnPropertyNames(o1);
    var props2 = Object.getOwnPropertyNames(o2);
    if (props1.length != props2.length) {
        return false;
    }
    for (var i = 0,max = props1.length; i < max; i++) {
        var propName = props1[i];
        if (o1[propName] !== o2[propName]) {
            return false;
        }
    }
    return true;
}
const InventoryAdjustVouching = Form.create()(
    class extends React.Component {
        constructor() {
            super();
            this.state = {
                userInfo: {},
                SelectData: {}, // 下拉框数据
                detailInfo: [], // 明细列表数据
                rowId: '', // 入库单Id
                tacitlyApproveData: {}, // 界面的默认数据
                pageSize: 10,
                page: 1,
                User: JSON.parse(window.sessionStorage.userData),
                statusCode: '',
                statusId: '',
                inOpLocDr: '',
                stkCat: '',
                ChineseEnglishSize: {}, //中英翻译
            };
            this.myRef1 = React.createRef();
            this.myRef2 = React.createRef();
            this.myRef3 = React.createRef();
            this.myRef4 = React.createRef();
            this.myRef5 = React.createRef();
            this.myRef6 = React.createRef();
            this.myRef7 = React.createRef();
            this.myRef8 = React.createRef();
            this.myRef9 = React.createRef();
        }

        componentDidMount() {
            // 初始化数据
            this.getSelectData();
            this.getTacitlyApproveData();
            this.getInOpLocDr();
        }

        componentWillUnmount() {
            // 组件销毁前将静止让setState修改state的状态，防止内存泄漏
            this.setState = (state,callback)=>{ return; }
        }

        onRef = (ref) => {
            this.childModal = ref;
        };

        detailOnRef = (ref) => {
            this.childDetail = ref;
        };
        onSelectRef = (ref) => {
            this.childSelect = ref;
        }

        // 获取下拉框的数据
        getSelectData() {
            let data = {
                params: []
            };
            $http.post('urlS', this, {
                code: "02020122",
                data: data,
                success: function (res) {
                    if (+res.errorCode === 0) {
                        this.setState({ SelectData: res })
                    } else {
                        this.setState({ SelectData: {} })
                    }
                }
            })
        }

        // 保存
        saveHandle = () => {
            let {ChineseEnglishSize} =this.state;
            if(this.childDetail.state.data.length < 1) {
                message.error(ChineseEnglishSize.DrugInventoryAdjustmentFormdetailUnitTips ? ChineseEnglishSize.DrugInventoryAdjustmentFormdetailUnitTips.descripts:"明细列表不能为空")
            } else {
                this.props.form.validateFields((errors, values) => {
                    let obj = JSON.parse(JSON.stringify(values));
                    if(errors == null){
                        let userList = this.state.userInfo ? this.state.userInfo : undefined;
                        let remark = this.props.form.getFieldValue('remark2');
                        let listId = this.childModal.state.rowId ? this.childModal.state.rowId : this.state.userInfo.stkAdjID;
                        let data = {
                            params: [{
                                stkAdjID: listId ? listId : undefined ,
                                locID: obj.loc ? obj.loc : undefined,
                                stkCatID: obj.stkCat ?  obj.stkCat : undefined,
                                remark: remark ? remark : "",
                                reasonID: obj.reasonDesc ?  obj.reasonDesc : "",
                                adjMethods: "手工建单",
                                detail: this.childDetail.state.data
                            }]
                        };
                        $http.post('urlS', this, {
                            code: "02020123",
                            data: data,
                            success: function (res) {
                                if (+res.errorCode === 0) {
                                    // 成功提示
                                    message.success(res.errorMessage);
                                    this.setState({statusCode: res.result.main.stateID , statusId: res.result.main.stkAdjID });
                                    this.childModal.setState({tableData: [], total: 0});
                                    this.getEchoData(res.result.main.stkAdjID);
                                }
                            },
                            error: function (err) {
                                console.log(err)
                            }
                        })
                    }
                })

            }

        };

        // 保存成功后根据返回回来的inOperateID重新查找数据
        getEchoData(id) {
            // 重置表单
            this.props.form.resetFields(); //清空所有
            this.setState({rowId: id}); // 将行id保存起来
            let data = {
                params: [
                    {
                        stkAdjID: id
                    }
                ],
                pagination: [
                    {
                        pageSize:this.state.pageSize,
                        currentPage:this.state.page,
                    }
                ],
            };
            $http.post('urlS', this, {
                code: "02020125",
                data: data,
                success: function (res) {
                    if (+res.errorCode === 0) {
                        for (let i = 0; i < res.detail.rows.length; i++) {
                            res.detail.rows[i].key = i + "main";
                        }
                        this.setState({userInfo: res.main, detailInfo: res.detail.rows});
                        // this.props.form.setFieldsValue(res.result[0].mainInfo[0]); // 将查询出来的数据回显
                    } else {
                        this.setState({userInfo: {}, detailInfo: []});
                    }
                }
            })
        }

        // 获取到部门的值
        getInOpLocDr = () => {
            let inOpLocDr = this.props.form.getFieldValue('loc');
            let stkCat = this.props.form.getFieldValue('stkCat');
            this.setState({inOpLocDr: inOpLocDr, stkCat: stkCat});
            return inOpLocDr
        }

        // 点击查询显示弹框
        inquireHandle = () => {
            this.getInOpLocDr();
            this.childModal.showModal(this.state.ChineseEnglishSize);
        };


        // 重置所有内容
        resetFieldsAll() {
            this.props.form.resetFields(); //清空所有
            this.setState({userInfo: {}, detailInfo: [], rowId: "",statusId: '',statusCode:'' });
            this.childDetail.resetFields();
            this.childDetail.deleteData();
            this.childModal.handleUncheck();
            this.childModal.setState({tableData: []});
        }

        // 重置表单
        resetFields = () => {
            this.resetFieldsAll()
        };

        // 删除
        handleDelete = () => {
            let data2 = {
                params: {
                    detail: [{
                        stkAdjDetailID:this.childDetail.state.userInfo&&this.childDetail.state.userInfo.stkAdjDetailID ? this.childDetail.state.userInfo.stkAdjDetailID: undefined,
                    }]
                }
            };
            let data3 = {
                params: {
                    main: [
                        {
                            stkAdjID: this.childModal.state.rowId ? this.childModal.state.rowId : this.state.statusId ? this.state.statusId : undefined,
                        }
                    ]
                }
            };
            $http.post('urlS', this, {
                code: "02020126",
                data: this.childDetail.state.userInfo&&this.childDetail.state.userInfo.stkAdjDetailID ? data2 : data3,
                success: function (res) {
                    if (+res.errorCode === 0) {
                        message.success(res.errorMessage);
                        this.resetFieldsAll();
                        this.childModal.setState({tableData : [],total: 0, userInfo: {}})
                    }
                }
            })
        };

        // 获取界面默认值
        getTacitlyApproveData() {
            let data = {
                params: []
            };
            $http.post('urlS', this, {
                code: "02020054",
                data: data,
                success: function (res) {
                    if (+res.errorCode === 0) {
                        this.setState({tacitlyApproveData: res.result[0]})
                    } else {
                        this.setState({tacitlyApproveData: {}})
                    }
                }
            })
        }
        //完成
        accomplish = () => {
            let userPOID =  this.state.userInfo.stkAdjID ?  this.state.userInfo.stkAdjID : undefined;
            let data = {
                params: [{
                    stkAdjID: this.state.statusId ? this.state.statusId : userPOID
                }]
            };
            $http.post('urlS', this, {
                code: "02020127",
                data: data,
                success: function (res) {
                    if (+res.errorCode === 0) {
                        message.success(res.errorMessage);
                        this.setState({statusCode: ''});
                        this.getEchoData(res.result.main.stkAdjID);
                        this.childModal.setState({tableData : [],total: 0})
                    }
                }
            })
        };
        //取消完成
        offAccomplish = () => {
            let userPOID =  this.state.userInfo.stkAdjID ?  this.state.userInfo.stkAdjID : undefined;
            let data = {
                params: [{
                    stkAdjID: this.state.statusId ? this.state.statusId : userPOID
                }]
            };
            $http.post('urlS', this, {
                code: "02020128",
                data: data,
                success: function (res) {
                    if (+res.errorCode === 0) {
                        message.success(res.errorMessage);
                        this.getEchoData(res.result.main.stkAdjID);
                        this.childModal.setState({tableData : [],total: 0})
                    }
                }
            })
        };

        //请求单弹窗双击后需要请求的数据
        onDoubleClickRequisition=(id )=>{

            let data = {
                params: [
                    {
                        stkReqID: id
                    }
                ]
            };
            $http.post('urlS', this, {
                code: "02020118",
                data: data,
                success: function (res) {
                    if (+res.errorCode === 0) {
                        for (let i = 0; i < res.result.detail.rows.length; i++) {
                            res.result.detail.rows[i].key = i + "main";
                        }
                        this.setState({userInfo: res.result.main, detailInfo: res.result.detail.rows});
                        message.success(res.errorMessage);
                        this.childDetail.setState({userInfo: {}, getBatchDetail: {}});
                        this.childSelect.setState({getBatchDetail: []})
                    }else {
                        this.setState({userInfo: {}, detailInfo: []});
                        this.childDetail.setState({userInfo: {}, getBatchDetail: {}});
                        this.childSelect.setState({getBatchDetail: []})
                    }
                }
            })

        };
        //获取中英版
        getChineseEnglishSize=(v)=>{
            this.setState({ChineseEnglishSize: v})
        };
        changeStkCat=(v)=>{
            this.setState({stkCat: v})
        };
        changesDesc=(v)=>{
            this.setState({inOpLocDr: v})
        };
        render() {
            const formItemInput  = {
                labelCol: { span: 6 },
                wrapperCol: { span: 18 },
            };
            const { getFieldDecorator } = this.props.form;
            let userInfo = this.state.userInfo ? this.state.userInfo: {};
            let user = this.state.User.locID ? this.state.User.locID: undefined;
            let userStatusCode = this.state.userInfo.stateID ? this.state.userInfo.stateID : '';
            let {ChineseEnglishSize} = this.state;
            return (
                <div className="inventoryAdjustVouching">
                    <Card
                        size="small"
                        title={<div className="card-title-left-icon"><div></div>{ChineseEnglishSize.DrugInventoryAdjustmentForminventoryAdjOrder ? ChineseEnglishSize.DrugInventoryAdjustmentForminventoryAdjOrder.descripts:'库存调整制单'}</div>}
                    >
                        <Row>
                            <Col span={18} className="top-form">
                                <Form>
                                    <Row>
                                        <Col span={8}>
                                            <Form.Item label={ChineseEnglishSize.DrugInventoryAdjustmentFormloc ? ChineseEnglishSize.DrugInventoryAdjustmentFormloc.descripts:'调整科室'} {...formItemInput}>
                                                {getFieldDecorator('loc', {
                                                    initialValue: userInfo.frLocID ? userInfo.frLocID+'' : user,
                                                    rules:[{ required : ChineseEnglishSize.DrugInventoryAdjustmentFormloc ? ChineseEnglishSize.DrugInventoryAdjustmentFormloc.required =='Y'? true:false: false, message: ChineseEnglishSize.DrugInventoryAdjustmentFormloc ? ChineseEnglishSize.DrugInventoryAdjustmentFormloc.message:'调整科室不能为空'}]
                                                })(
                                                    <Select showSearch allowClear placeholder={ChineseEnglishSize.DrugInventoryAdjustmentFormlocTips ? ChineseEnglishSize.DrugInventoryAdjustmentFormlocTips.descripts:'请选择调整科室'} onChange={this.changesDesc}>
                                                        {this.state.SelectData.loc && this.state.SelectData.loc.map(item => {
                                                            return <Option key={item.id} value={item.id} >{item.descripts}</Option>
                                                        })}
                                                    </Select>
                                                )}
                                            </Form.Item>
                                        </Col>
                                        <Col span={8}>
                                            <Form.Item label={ChineseEnglishSize.DrugInventoryAdjustmentFormstkAdjNO ? ChineseEnglishSize.DrugInventoryAdjustmentFormstkAdjNO.descripts:'调整单号'} {...formItemInput}>
                                                {getFieldDecorator('stkAdjNO', {
                                                    initialValue: userInfo.stkAdjNO ? userInfo.stkAdjNO : undefined,
                                                })(
                                                    <Input disabled />
                                                )}
                                            </Form.Item>
                                        </Col>
                                        <Col span={8}>
                                            <Form.Item label={ChineseEnglishSize.DrugInventoryAdjustmentFormreasonDesc ? ChineseEnglishSize.DrugInventoryAdjustmentFormreasonDesc.descripts:'调整原因'} {...formItemInput}>
                                                {getFieldDecorator('reasonDesc', {
                                                    initialValue: userInfo.reasonID ? userInfo.reasonID : undefined,
                                                    rules: [{ required: false, message: '调整原因不能为空' }]
                                                })(
                                                    <Select showSearch allowClear placeholder={ChineseEnglishSize.DrugInventoryAdjustmentFormreasonDescTips ? ChineseEnglishSize.DrugInventoryAdjustmentFormreasonDescTips.descripts:'请选择调整原因'} >
                                                        {this.state.SelectData.reason && this.state.SelectData.reason.map(item => {
                                                            return <Option key={item.id} value={item.id} >{item.descripts}</Option>
                                                        })}
                                                    </Select>
                                                )}
                                            </Form.Item>
                                        </Col>
                                    </Row>
                                    <Row>
                                        <Col span={8}>
                                            <Form.Item label={ChineseEnglishSize.DrugInventoryAdjustmentFormstkCatID ? ChineseEnglishSize.DrugInventoryAdjustmentFormstkCatID.descripts:'库存大类'} {...formItemInput}>
                                                {getFieldDecorator('stkCat', {
                                                    initialValue: userInfo.stkCatID ? userInfo.stkCatID+'' : undefined,
                                                    rules: [{ required: false, message: '库存大类不能为空' }]
                                                })(
                                                    <Select showSearch allowClear placeholder={ChineseEnglishSize.DrugInventoryAdjustmentFormstkCatTips ? ChineseEnglishSize.DrugInventoryAdjustmentFormstkCatTips.descripts:'请选择库存大类'} onChange={this.changeStkCat}>
                                                        {this.state.SelectData.stkCat && this.state.SelectData.stkCat.map(item => {
                                                            return <Option key={item.id} value={item.id}>{item.descripts}</Option>
                                                        })}
                                                    </Select>
                                                )}
                                            </Form.Item>
                                        </Col>
                                        <Col span={8}>
                                            <Form.Item label={ChineseEnglishSize.DrugInventoryAdjustmentFormstatus ? ChineseEnglishSize.DrugInventoryAdjustmentFormstatus.descripts:'单据状态'} {...formItemInput}>
                                                {getFieldDecorator('stkCat2', {
                                                    initialValue: userInfo.stateID ? userInfo.stateID : undefined,
                                                    rules: [{ required: false}]
                                                })(
                                                    <Select showSearch allowClear disabled>
                                                        {this.state.SelectData.state && this.state.SelectData.state.map(item => {
                                                            return <Option key={item.id} value={item.id}>{item.descripts}</Option>
                                                        })}
                                                    </Select>
                                                )}
                                            </Form.Item>
                                        </Col>
                                        <Col span={8}>
                                            <Form.Item label={ChineseEnglishSize.DrugInventoryAdjustmentFormcrStartDate ? ChineseEnglishSize.DrugInventoryAdjustmentFormcrStartDate.descripts:'制单日期'} {...formItemInput}>
                                                {getFieldDecorator('StartDate', {
                                                    initialValue: userInfo.createDate ? userInfo.createDate: undefined,
                                                })(
                                                    <Input  disabled />
                                                )}
                                            </Form.Item>
                                        </Col>

                                    </Row>
                                    <Row>
                                        <Col span={8}>
                                            <Form.Item label={ChineseEnglishSize.DrugInventoryAdjustmentFormremark2 ? ChineseEnglishSize.DrugInventoryAdjustmentFormremark2.descripts:'备注'} {...formItemInput}>
                                                {getFieldDecorator('remark2', {
                                                    initialValue: userInfo.remark ? userInfo.remark : undefined,
                                                })(
                                                    <TextArea rows={1} style={{width: '100%'}} />
                                                )}
                                            </Form.Item>
                                        </Col>
                                    </Row>
                                </Form>
                            </Col>
                            <Col span={5} style={{marginLeft: '33px'}}>
                                <Row style={{marginBottom: '20px',marginTop: '5px'}}>
                                    <Button style={{marginRight: '30px'}} onClick={this.inquireHandle}>{ChineseEnglishSize.DrugInventoryAdjustmentFormsearch ? ChineseEnglishSize.DrugInventoryAdjustmentFormsearch.descripts:'查询'}</Button>
                                    <Button type="primary" style={{marginRight: '30px'}} onClick={this.saveHandle}>{ChineseEnglishSize.DrugInventoryAdjustmentFormsave ? ChineseEnglishSize.DrugInventoryAdjustmentFormsave.descripts:'保存'}</Button>
                                    <Button disabled={this.state.statusCode == 10 ? false : userStatusCode == 10 ? false : true} onClick={this.accomplish}>{ChineseEnglishSize.DrugInventoryAdjustmentFormaccomplish ? ChineseEnglishSize.DrugInventoryAdjustmentFormaccomplish.descripts:'完成'}</Button>
                                </Row>
                                <Row>
                                    <Popconfirm title={ChineseEnglishSize.DrugInventoryAdjustmentFormresetTips ? ChineseEnglishSize.DrugInventoryAdjustmentFormresetTips.descripts:"重置后将初始化数据，你确定要重置吗?"} onConfirm={this.resetFields} okText={this.state.User.language == 'EN' ? "Yes" : '是'}cancelText={this.state.User.language == 'EN' ? "No" : '否'}>
                                        <Button style={{marginRight: '30px'}} >{ChineseEnglishSize.DrugInventoryAdjustmentFormReset ? ChineseEnglishSize.DrugInventoryAdjustmentFormReset.descripts:'重置'}</Button>
                                    </Popconfirm>
                                    <Popconfirm title={ChineseEnglishSize.DrugInventoryAdjustmentFormdeleteTips ? ChineseEnglishSize.DrugInventoryAdjustmentFormdeleteTips.descripts:"删除不可恢复，你确定要删除吗?"} onConfirm={this.handleDelete} okText={this.state.User.language == 'EN' ? "Yes" : '是'}cancelText={this.state.User.language == 'EN' ? "No" : '否'}>
                                        <Button type="danger" style={{marginRight: '30px'}}>{ChineseEnglishSize.DrugInventoryAdjustmentFormdelete ? ChineseEnglishSize.DrugInventoryAdjustmentFormdelete.descripts:'删除'}</Button>
                                    </Popconfirm>
                                    <Button disabled={this.state.statusCode == 20 ? false : userStatusCode == 20 ? false : true} onClick={this.offAccomplish}>{ChineseEnglishSize.DrugInventoryAdjustmentFormcancelComplete ? ChineseEnglishSize.DrugInventoryAdjustmentFormcancelComplete.descripts:'取消完成'}</Button>
                                </Row>
                                <Row style={{marginTop:'20px'}}>
                                    <Button type="dashed" onClick={printStkAdj.bind(this,this.state.rowId)}>{ChineseEnglishSize.DrugInventoryAdjustmentFormprint ? ChineseEnglishSize.DrugInventoryAdjustmentFormprint.descripts:'打印'}</Button>
                                </Row>
                            </Col>
                        </Row>
                    </Card>
                    <AdjustmentDetailList SelectData={this.state.SelectData} onRef={this.detailOnRef} detailInfo={this.state.detailInfo} handleThis={this} inOpLocDr={this.state.inOpLocDr} stkCat={this.state.stkCat} />
                    <InquireShift SelectData={this.state.SelectData} onRef={this.onRef} inOpLocDr={this.state.inOpLocDr ? this.state.inOpLocDr : ''} handleThis={this} />
                </div>
            )
        }
    }
);
export default InventoryAdjustVouching;